%global version_major 2
%global version_minor 9
%global version_micro 1
%global commitid ee4693973053db23f6694e7d6a79a1e37c8a0332
%global serial 18
%{?scl:%scl_package %{?scl_prefix}mod_security}
%{!?scl:%global pkg_name %{name}}

%define _jarsign_opts --nocopy
%bcond_without zip

%define reltag GA

Name: %{?scl_prefix}mod_security
Summary: Open Source Web Application Firewall
Version: 2.9.1
Release: %{serial}.%{reltag}%{?dist}
License: ASL 2.0
URL: https://www.modsecurity.org/

# https://www.modsecurity.org/tarball/2.8.0/modsecurity-2.8.0.tar.gz
# mv mod_security-2.8.0.tar.gz mod_security-2.8.0.tar.gz.orig
# mv modsecurity-2.8.0 mod_security-2.8.0
# tar czf mod_security-2.8.0.tgz mod_security-2.8.0
Source0: ModSecurity-%{commitid}.tar.gz
Source1: mod_security.conf
Source2: 10-mod_security.conf

Group: Development/Libraries

BuildRoot: %{_tmppath}/%{name}-%{version}-buildroot

%if "%{?rhel}" == "7"
# 64 bit only natives on RHEL7
ExcludeArch: i386 i686
%endif

%if "%{?rhel}" == "6"
BuildRequires: perl
BuildRequires: zip
%endif

BuildRequires: libtool
BuildRequires: %{?scl_prefix}httpd-devel
BuildRequires: curl-devel
BuildRequires: libxml2-devel

BuildRequires: pcre-devel
#Mladen asked to add this BR to fix JWS-203
BuildRequires: lua-devel

BuildRequires: chrpath
BuildRequires: openldap-devel, expat-devel

Requires: %{?scl_prefix}httpd

%description
Open Source Web Application Firewall

%if %with zip
%package src-zip
Summary:     Container for the source distribution of mod_security
Group:       Development

%description src-zip
Container for the source distribution of mod_security.
%endif

%prep
%setup -q -n ModSecurity-%{commitid}

#Create src zip to include any patches
%if %with zip
zip -q -r %{name}-%{version}-src.zip *
%endif

%build
%{?scl:scl enable %scl - << \EOF}
set -e
./autogen.sh
sh ./configure --disable-rpath --with-apxs=/opt/rh/jbcs-httpd24/root/usr/sbin/apxs --with-apr=/opt/rh/jbcs-httpd24/root/usr/bin/apr-1-config --with-apu=/opt/rh/jbcs-httpd24/root/usr/bin/apu-1-config
make
%{?scl:EOF}

%install
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{_libdir}/httpd/modules/ \
         $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d
mkdir -p $RPM_BUILD_ROOT%{_bindir}
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/httpd/modsecurity.d/
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/httpd/modsecurity.d/activated_rules

install -Dp -m0644 %{SOURCE2} %{buildroot}%{_sysconfdir}/httpd/conf.modules.d/10-mod_security.conf
install -Dp -m0644 %{SOURCE1} %{buildroot}%{_sysconfdir}/httpd/conf.d/mod_security.conf
sed  -i 's/Include/IncludeOptional/'  %{buildroot}%{_sysconfdir}/httpd/conf.d/mod_security.conf
install -m 700 -d $RPM_BUILD_ROOT%{_localstatedir}/lib/mod_security

cp apache2/.libs/mod_security2.so $RPM_BUILD_ROOT%{_libdir}/httpd/modules/mod_security2.so
cp tools/rules-updater.pl $RPM_BUILD_ROOT%{_bindir}/rules-updater.pl
#JWS-199
rm $RPM_BUILD_ROOT%{_bindir}/rules-updater.pl
cp mlogc/mlogc $RPM_BUILD_ROOT%{_bindir}/mlogc
cp mlogc/mlogc-batch-load.pl $RPM_BUILD_ROOT%{_bindir}/mlogc-batch-load.pl

%if %with zip
mkdir -p $RPM_BUILD_ROOT%{_javadir}/jbossas-fordev
cp %{name}-%{version}-src.zip $RPM_BUILD_ROOT%{_javadir}/jbossas-fordev/
%endif

%{?scl:%{_root_bindir}}%{!?scl:%{_bindir}}/chrpath -d $RPM_BUILD_ROOT%{_libdir}/httpd/modules/mod_security2.so

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc authors.txt CHANGES LICENSE NOTICE README.TXT
# %config(noreplace) %{_sysconfdir}/httpd/conf.d/mod_snmp.conf.sample
# %config(noreplace) %{_sysconfdir}/httpd/conf.d/snmpd/snmpd.conf.sample
%{_libdir}/httpd/modules/*.so
%{_bindir}/*
%config(noreplace) %{_sysconfdir}/httpd/conf.d/*.conf
%config(noreplace) %{_sysconfdir}/httpd/conf.modules.d/*.conf
%dir %{_sysconfdir}/httpd/modsecurity.d
%dir %{_sysconfdir}/httpd/modsecurity.d/activated_rules
%attr(770,apache,root) %dir %{_localstatedir}/lib/mod_security

%if %with zip
%files src-zip
%defattr(-,root,root,-)
%{_javadir}/jbossas-fordev/*
%endif

%changelog
* Fri Dec 02 2016 Georgios Zaronikas Karagiannis <gzaronik@redhat.com> - 2.9.1-18
- Build for CR1

* Wed Oct 26 2016 Hui Wang <huwang@redhat.com> - 2.9.1-17
- Rebuild

* Mon Oct 10 2016 Jean-Frederic Clere <jclere@redhat.com> - 2.9.1-17
- remove JWS3 refrences: Fix JBCS-187

* Mon Oct 03 2016 Georgios Zaronikas Karagiannis <gzaronik@redhat.com> - 2.9.1-16
- Changing lookaside sources to contain patch for JWS-489

* Mon Sep 19 2016 Coty Sutherland <csutherl@redhat.com> - 2.9.1-16
- Resolves: JWS3-56 Ship a template configuration file for mod_security with httpd

* Thu Aug 18 2016 Patrick Sutherland <csutherl@redhat.com> - 2.9.1-15
-

* Mon Jul 25 2016 Patrick Sutherland <csutherl@redhat.com> - 2.9.1-14
-

* Mon Jul 25 2016 Coty Sutherland <csutherl@redhat.com> - 0:2.9.1-2
- Resolves: JBCS-120 update mod_security to 2.9.1

* Tue Jul 19 2016 Jean-Frederic Clere <jclere@redhat.com> - 0:2.9.1-1
- update to latest version.

* Mon Mar 21 2016 David Walluck <dwalluck@redhat.com> - 2.8.0-13
- fix rpath

* Mon Mar 21 2016 Fernando Nasser <fnasser@redhat.com> - 2.8.0-12
- Remove rpath

* Tue Feb 16 2016 Fernando Nasser <fnasser@redhat.com> - 2.8.0-11
- Build from source-repos

* Thu Jan 28 2016 Fernando Nasser <fnasser@redhat.com> - 0:2.8.0-9
- Build in the jbcs-httpd24 collection

* Thu Jan 28 2016 Hui Wang <huwang@redhat.com> - 0:2.8.0-7
- Mladen adviced to add BR lua-devel to fix jws-203

* Mon Dec 21 2015 Fernando Nasser <fnasser@redhat.com> - 0:2.8.0-7
- Build in the jbcs-httpd24 collection

* Tue Aug 18 2015 Weinan Li <weli@redhat.com> - 0:2.8.0-6
- JWS-199 Apache HTTP rules updater is obsolete

* Tue Jan 06 2015 Weinan Li <weli@redhat.com> - 0:2.8.0-5
- Fix jws3 renaming

* Thu Nov 27 2014 Weinan Li <weli@redhat.com> - 0:2.8.0-4
- move mlogc to mlogc-jws3

* Wed Nov 26 2014 Weinan Li <weli@redhat.com> - 0:2.8.0-3
- rename to mod_security-jws3

* Mon Nov 17 2014 Weinan Li <weli@redhat.com> - 0:2.8.0-2
- Rebuild to enable zip across all platforms

* Tue Oct 21 2014 Weinan Li <weli@redhat.com> - 0:2.8.0-1
- Initial import
